import React, { useState, useRef, useCallback, useEffect } from 'react';

var OtpInput = function (_a) {
    var _b = _a.otpFields, otpFields = _b === void 0 ? 5 : _b, onCodeFilled = _a.onCodeFilled, _c = _a.autoFocus, autoFocus = _c === void 0 ? false : _c, _d = _a.disabled, disabled = _d === void 0 ? false : _d, _e = _a.value, value = _e === void 0 ? "" : _e, _f = _a.placeholder, placeholder = _f === void 0 ? "-" : _f;
    var _g = useState(0), activeInput = _g[0], setActiveInput = _g[1];
    var _h = useState(value), otp = _h[0], setOtp = _h[1];
    var inputRef = useRef(new Array(otpFields).fill(""));
    var handleChange = function (e) {
        if (/\d/.test(e.target.value) && e.target.value !== "") {
            var updateOtp = Array.from(otp);
            updateOtp[activeInput] = e.target.value;
            setOtp(updateOtp.join(""));
            if (updateOtp.length < otpFields) {
                setActiveInput(function (prev) { return prev + 1; });
            }
        }
    };
    var handleFocus = useCallback(function () {
        inputRef[activeInput].focus();
    }, [activeInput]);
    var handleOTPDeletion = function (e) {
        if (e.key === "Backspace" && otp.length > 0) {
            var updateOtp = Array.from(otp);
            updateOtp[activeInput] = "";
            setOtp(updateOtp.join(""));
            if (activeInput > 0) {
                setActiveInput(function (prev) { return prev - 1; });
            }
        }
    };
    var handlePaste = function (e) {
        var pasteData = e.clipboardData
            .getData("text/plain")
            .trim()
            .slice(0, otpFields)
            .split("");
        setOtp(pasteData);
        setActiveInput(pasteData.length - 1);
    };
    useEffect(function () {
        if (activeInput >= 0 && activeInput < otpFields) {
            handleFocus();
        }
    }, [activeInput]);
    useEffect(function () {
        if (otp.length === otpFields) {
            onCodeFilled(otp);
        }
    }, [otp]);
    return (React.createElement("div", null, new Array(otpFields).fill("").map(function (i, index) { return (React.createElement("input", { type: "text", placeholder: placeholder, value: otp[index] || "", onChange: handleChange, onKeyDown: handleOTPDeletion, maxLength: 1, key: index, autoFocus: autoFocus, ref: function (ref) { return (inputRef[index] = ref); }, disabled: disabled, onPaste: handlePaste, style: {
            width: "56px",
            height: "56px",
            marginRight: "10px",
            border: "1px solid #d9d9d9",
            boxSizing: "border-box",
            boxShadow: "0px 0.5px 2px rgba(0,0,0,0.1)",
            borderRadius: "10px",
            textAlign: "center",
        } })); })));
};

export { OtpInput as default };
//# sourceMappingURL=index.js.map
